{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE GUI}
unit VT10f;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes,
  Math, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, DateUtils, Clipbrd, ComCtrls,
  Grids, ValEdit, AfDataDispatcher, AfComPort; // last two from Asyncfree

type
  TVidTrak10f = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    RadioGroup1: TRadioGroup;
    Stopper: TCheckBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Format: TButton;
    Display: TButton;
    Distance: TLabel;
    Auto: TCheckBox;
    Homer: TCheckBox;
    tracker: TCheckBox;
    TrackStatus: TLabel;
    Progress: TLabel;
    Mount: TButton;
    Pulsed: TButton;
    PickStar: TEdit;
    Label9: TLabel;
    TrackGain: TTrackBar;
    Label10: TLabel;
    ObjName: TButton;
    Sync: TButton;
    Paramedit: TButton;
    Memo1: TMemo;
    ParamSave: TButton;
    Label12: TLabel;
    Step: TButton;
    FrameRate: TButton;
    Intensity: TButton;
    Label15: TLabel;
    AfComPort1: TAfComPort;
    BoreUp: TButton;
    Boresight: TButton;
    BoreDown: TButton;
    BoreLeft: TButton;
    BoreRight: TButton;
    BORE: TLabel;
    Label16: TLabel;
    Label11: TLabel;
    Ratio: TButton;
    zero: TButton;
    Threshold: TEdit;
    Label17: TLabel;
    Label13: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Cleanup(Sender: TObject; var Action: TCloseAction);
    procedure KeyCommand(Sender: TObject; var Key: Char);
    procedure RadioGroup1Click(Sender: TObject);
    procedure GoNorth(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure StopNorth(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GoWest(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure StopWest(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GoSouth(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure StopSouth(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GoEast(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure StopEast(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure StopperClick(Sender: TObject);
    procedure FormatClick(Sender: TObject);
    procedure DisplayClick(Sender: TObject);
    procedure AutoClick(Sender: TObject);
    procedure HomerClick(Sender: TObject);
    procedure trackerClick(Sender: TObject);
    procedure setfield(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure StartFocIn(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure StopFocIn(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure StartFocOut(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure StopFocOut(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PulsedClick(Sender: TObject);
    procedure SeekStar(Sender: TObject; var Key: Char);
    procedure TrackGainChange(Sender: TObject);
    procedure SyncClick(Sender: TObject);
    procedure loadfile(Sender: TObject);
    procedure ParameditClick(Sender: TObject);
    procedure ParamSaveClick(Sender: TObject);
    procedure StepClick(Sender: TObject);
    procedure BoresightClick(Sender: TObject);
    procedure BoreUpClick(Sender: TObject);
    procedure BoreRightClick(Sender: TObject);
    procedure BoreDownClick(Sender: TObject);
    procedure BoreLeftClick(Sender: TObject);
    procedure zeroClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    HwndC: HWND;
    procedure idleloop(Sender: TObject; var Done: boolean);
  end;


var
  VidTrak10f: TVidTrak10f;

implementation

{$R *.dfm}

const maxdata = 4000*15;
      maxparams = 12;
      DEClimit = 65.0;
      maxsegments = 30;
      specialterm = '#';
      getsidtime = ':GS#';
      getTelRA = ':GR#';
      getTelDEC = ':GD#';
      getObjRA = ':Gr#';
      getObjDEC = ':Gd#';
      setObjRA = ':Sr ';
      setObjDEC = ':Sd ';
      SlewTel = ':MS#';
      WM_CAP_START                  = WM_USER;
      WM_CAP_DRIVER_CONNECT         = WM_CAP_START + 10;
      WM_CAP_DRIVER_DISCONNECT      = WM_CAP_START + 11;
      WM_CAP_EDIT_COPY              = WM_CAP_START+  30;
      WM_CAP_DLG_VIDEOFORMAT        = WM_CAP_START+  41;
      WM_CAP_DLG_VIDEOSOURCE        = WM_CAP_START+  42;
      WM_CAP_GRAB_FRAME             = WM_CAP_START + 60;
      WM_CAP_ABORT                  = WM_CAP_START+  69;

      Paramlegends: array[0..maxparams - 1] of string =
                    ('RefDec    = ','RefRA     = ','TimeZone  = ',
                     'ComPort   = ','Focal L   = ','FrameRate = ',
                     'Pixels X  = ','Pixels Y  = ','HSign     = ',
                     'VSign     = ','','');


type DecimalType = array[1..maxdata] OF double;
     StringType = array[1..maxdata] of string[9];
     intptrtype = ^integer;

var paramfile: text;
    TimeZone, ComPort: integer;
    timestr: string;
    Focusstr, Commandstr: string;
    dataptr,lastdataptr: word;
    RAlist, DEClist, AltList, AZlist: ^DecimalType;
    TIMElist: ^StringType;
    SidTimeString,TelRAstring,TelDECstring: string;
    objRAstring,ObjDECString,SaveObjRAstring,SaveObjDECString: string;
    TelRA, TelDEC, ObjRA, ObjDEC: double;
    ThisRA, NextRA, ThisDEC, NextDEC: double;
    deltaRA, deltaDEC: double;
    buffer,instr: string;
    segment,nsegments: integer;
    stage: integer;
    starttime,timenow: TDatetime;
    stop, iterating, isComPort, autoon, pulse, editing,
      polar, limDEC, nodata, memoOK, slewdone,
      moveframe: boolean;
    freq, segtime: int64;
    timesec: double;
    Tstart,TEnd,maxval, avgval: int64;
    maxtime: Double;
    t1,t2,s1,s2,s3: int64;
    slow: integer;
    ch: char;
    errRA,errDEC, peakx, peaky: double;
    cornerRA, cornerDEC, refRA, refDEC,
      borestate, borestep: integer;
    autoDEC, autoRA: double;
    bestx, besty, peak: integer;
    thresh: double;
    Bitmap1, Bitmap2: TBitmap;
    t,t3,t4: int64;
    fieldwidth, fieldheight,startraksize,halfframe: integer;
    field: TRect;
    fieldx, fieldy: integer;
    fieldradius: integer;
    stepsize, Yoffset, Xoffset: integer;
    FL: integer;
    gain, gainfactor: double;
    HSign,VSign: integer;
    latitude: double;
    fieldscale: double;
    alignment: char;
    maplist: array[0..199] of pByteArray;  // must be zero-based

const paramadr: array[0..maxparams - 1] of intptrtype =
                  (@RefDec,@RefRA,@TimeZone,@ComPort,
                   @FL,@Nsegments,@fieldwidth,@fieldheight,
                   @HSign,@VSign,NIL,NIL);

    procedure SetLongForm; forward;

   function capCreateCaptureWindowA(lpszWindowName : PCHAR;
                                    dwStyle : longint;
                                    x : integer;
                                    y : integer;
                                    nWidth : integer;
                                    nHeight : integer;
                                    ParentWin  : HWND;
                                    nId : integer): HWND;
                                    STDCALL EXTERNAL 'AVICAP32.DLL';

   { INPUT AND OUTPUT ANGLES IN DEGREES}
   procedure convertaltaz(altitude, azimuth: double; var ha,dec: double);
   var k,l,temp: double;
       alt, az, sinhour,sindec, cosdec, newdec, newha: double;
   begin
    k := pi/180.0;   // degrees to radians
    l := k*latitude;
    if l = 0.0 then l := 0.0001;
    alt := k*altitude;
    az := k*azimuth;
    sindec := sin(alt)*sin(l) -
                  cos(alt)*cos(l)*cos(az);
    cosdec := sqrt(1 - sqr(sindec));
    if (cosdec < 0.01) and (cosdec >= 0.0) then cosdec := 0.01
    else
    if (cosdec > -0.01) and (cosdec <= 0.0) then cosdec := -0.01;
    temp := arccos(cosdec);
    if sindec > 0.0 then newdec := temp
    else newdec := -temp;
    sinhour := -sin(az)*cos(alt)/cosdec;
    newha := arcsin(sinhour);
    if (azimuth > 90.0) and (azimuth <= 180) then newha := -(pi + newha)
    else
    if (azimuth > 180.0) and (azimuth <= 270.0) then newha := (pi - newha);
    ha := -newha/k;                 // radians to degrees
    dec := newdec/k;               // dec in degrees
   end;

   {INPUT AND OUTPUT ANGLES IN DEGREES}
   procedure ErrAltAzToErrRaDec(alt,az, dalt, daz: double;
                       var ddec, dha: double);
   var newHA, newDEC, oldHA, oldDEC: double;
       i: integer;
   begin
    oldHA := 0; oldDEC := 0;
    for i := 0 to 1 do
    begin
     convertaltaz(alt + i*dalt, az+i*daz, newHA, newDEC);
     if i = 0 then
      begin
       oldDEC := newDEC;
       oldHA := -newHA;       // hour angle increases West
      end                     // so RA decreases as HA increases
     else
      begin
       ddec :=  newdec - olddec;
       dHA := -newHA - oldHA;
      end;
    end;
   end;


   procedure writestatus(s: string);
   begin
    VidTrak10f.TrackStatus.Caption := s;
   end;


   procedure StopVideo;
   begin
    if VidTrak10f.hWndC <> 0 then
     SendMessage(VidTrak10f.hWndC, WM_CAP_DRIVER_DISCONNECT, 0, 0);
   end;

   procedure GrabFrame;
   begin
    if VidTrak10f.hWndC <> 0 then
     begin
      clipboard.clear;
      SendMessage(VidTrak10f.hWndC, WM_CAP_GRAB_FRAME, 0, 0); // make invisible
      SendMessage(VidTrak10f.hWndC, WM_CAP_EDIT_COPY, 0, 0); // buffer to clipbd
     end;
   end;

  procedure limitfield;
  begin
       if cornerDEC < 1 then cornerDEC := 1
    else
    if cornerDEC > fieldheight - StarTrakSize - 2 then
     cornerDEC := fieldheight - StarTrakSize - 2;
    if cornerRA < 1 then cornerRA := 1
    else
    if cornerRA > fieldwidth - StarTrakSize - 2 then
     cornerRA := fieldwidth - StarTrakSize - 2;
  end;

  procedure CopyFrame;   // field tracks brightest point
   var x, y, intensity, d: integer;
       dest,c: Trect;
       errAZ, errALT, sum, num, avg: double;
   begin
     dest := rect(0,0,StarTrakSize,StarTrakSize);
     if moveframe then
     begin
      cornerRA := round(peakx) - halfframe + 1;
      cornerDEC := round(peaky) - halfframe + 1;
     end;
     if clipboard.HasFormat(CF_bitmap) then
     bitmap1.assign(clipboard);
     with bitmap1.canvas do
     begin
           c := rect(round(refRA)  - 5,
                round(refDEC) - 4,
                round(refRA)  + 5,       //about 4' x 5' rect, fl = 102 mm
                round(refDEC) + 4);
      brush.color := RGB(0,255,0);
      framerect(c);

      brush.Color := RGB(200,0,0);
      framerect(rect(cornerRA - 1 , cornerDEC - 1,
                cornerRA + StarTrakSize,cornerDEC + StarTrakSize));
     end;
     limitfield;
     field := Rect(cornerRA, cornerDEC,
               cornerRA + StarTrakSize - 1,cornerDEC + StarTrakSize - 1);
     bitmap2.canvas.copyrect(dest,bitmap1.canvas,field);
     VidTrak10f.canvas.draw(0,0,bitmap1);
     bestx := halfframe;
     besty := halfframe;
     peak := 0;
     sum := 0.0;
     num := 0;
     for y := 0 to StarTrakSize - 1 do
      for x := 0 to StarTrakSize - 1 do
       begin
        intensity := maplist[y][3*x+2];
        sum := sum + intensity;
        if peak < intensity then
          begin
           peak := intensity;
           bestx := x;
           besty := y;
          end;
         num := num + 1.0;
       end;
     VidTrak10f.intensity.caption := inttostr(peak);
     avg := sum/num;
     if avg < 10 then avg := 10;
     sum := peak/avg;
     val(VidTrak10f.threshold.text,thresh,d);
     if d <> 0 then thresh := 1.1;
     vidtrak10f.ratio.caption := floattostrf(sum,fffixed,5,2);
     peakx := cornerRA + bestx;
     peaky := cornerDEC + besty;
     limitfield;
     field := Rect(cornerRA, cornerDEC,
               cornerRA + StarTrakSize - 1,cornerDEC + StarTrakSize - 1);
     if autoon then
       begin
        errAZ := fieldscale*(peakx - refRA);    // position error, degrees
        errALT := fieldscale*( peaky - refDEC);
        if alignment = 'A' then
         ErrAltAzToErrRaDec(ALTlist^[dataptr], AZlist^[dataptr],
                          ErrALT,ErrAZ,ErrDEC,ErrRA)
        else
         begin
          errRA := errAZ;
          errDEC := errALT;
         end;
       end
      else
       begin
        errRA := 0;
        errDEC := 0;
       end;
     if sum < thresh then
     begin
      errRA := 0.0;        // don't change correction
      errDEC := 0.0;
      moveframe := false;  // freeze red frame, too
     end
     else moveframe := true;
   end;

procedure delay(n: double);
var limit,i1,i2: int64;
begin
 limit := round(0.001*freq*n);
 QueryPerformanceCounter(i1);
 repeat
  QueryPerformanceCounter(i2);
  application.ProcessMessages;
 until i2 - i1 > limit;
end;

procedure doParamEdit;
var i: integer;
begin
 with VidTrak10f.memo1 do
 If stage = 0 then
 begin
  for i := 0 to maxparams-1 do
   lines.add(' ');
  for i := 0 to maxparams-1 do
   if paramlegends[i] <> '' then
   lines[i] := paramlegends[i];
  for i := 0 to maxparams-1 do
   if paramadr[i] <> nil then
   lines[i] := lines[i] + '    ' + inttostr(paramadr[i]^);
 end;
 memoOK := true;
end;

procedure storeparams;
begin
 rewrite(paramfile);
 writeln(paramfile,RefDEC);
 writeln(paramfile, RefRA);
 writeln(paramfile,TimeZone);
 writeln(paramfile, ComPort);
 FL := round(exp(0.001*VidTrak10f.Trackgain.position));
 writeln(paramfile, FL);
 writeln(paramfile,Nsegments);
 writeln(paramfile,fieldwidth);
 writeln(paramfile,fieldheight);
 writeln(paramfile,HSign);
 writeln(paramfile,Vsign);
 closefile(paramfile);
end;

procedure doParamsave;
var i: integer;
    numstr: string;
begin
 with VidTrak10f do
 begin
  if memoOK then
  begin
   for i := 0 to maxparams-1 do
   begin
    numstr := copy(memo1.lines[i],
                   pos('=',memo1.lines[i]) + 1,20);
    if paramadr[i] <> nil then
     paramadr[i]^ := strtointdef(numstr,0);
   end;
   trackgain.Position := round(1000.0*ln(1.0*FL));
   segtime := freq div nsegments;
   storeparams;
  end;
 memo1.clear;
 memoOK := false;
 maxval := 0;
 avgval := 0;
 end;
end;

function ComTxString(s: string): boolean;
begin
 with  VidTrak10f.afComPort1 do
  begin
   if OutBufFree >= length(s) then
    begin
     WriteString(s);
     result := true;
    end
    else result := false;
  end;
end;

function ComRxString(var s: string; ch: char): boolean;
 var t: TDateTime;
     timeout: boolean;
     instring: string;
     c: char;
begin
 t := time;
 c := #0;
 instring := '';
 if ch in ['2','1','0'] then
 begin
  with VidTrak10f,afComPort1 do
  repeat
   if (InBufUsed > 0) then c := readchar;
   timeout := (time - t)*86400.0 > 2.0;
  until (c in ['2','1','0']) or timeout;
  if not timeout then
  begin
   instring := instring + c;
   s := instring
  end
  else
   s := '';
 end
 else
 begin
  t := time;
  with VidTrak10f,afComPort1 do
  repeat
   while InBufUsed > 0 do
    begin
     c := readchar;
     instring := instring + c;
    end;
   timeout := (time - t)*86400.0 > 5.0;
  until (c = ch) or timeout;
  if not timeout then s := instring
  else s := '';
 end;
 result :=  not timeout;
end;

procedure SetTelTime;
var timenow,thisdate,thisstring: string;
    t: TDateTime;
begin
 with VidTrak10f do
 with afComPort1 do
 begin
  t := time;
  DateTimeToString(timenow,'hh:nn:ss#', t);
  DateTimeToString(thisdate,'mm/dd/yy#',today);
  writestatus(timenow + '  ' + thisdate);
  writestring(':SL '+ timenow);           // write string to RS232 port
  if ComRxString(thisstring,'0') then
   writestatus(thisstring)
  else writestatus('Time not acknowledged');
  writestring(':SC ' + thisdate);
  if ComRxString(thisstring,'1') then
   writestatus(thisstring)
  else writestatus('Date not acknowledged');
  thisstring := '';
  if comRxString(thisstring,'#') then
     writestatus(thisstring)
  else
   writestatus('No response from telescope');
  thisstring := '';
  if comRxString(thisstring,'#') then
     writestatus(thisstring)
  else
   writestatus('No response from telescope');

 end;
end;

 {CONVERT HH:MM:SS or HH.FRACTION TO DOUBLE,
  ignore terminating "#" if any}
{Note: if fraction, 5 digits expected}
function RAtoDouble(var RAstr:string): double;
var h, m, s, tdbl: double;
    code: integer;

begin
  if RAstr = '' then RAstr := SidTimeString;

 if RAstr[3] = ':' then  {Format is HH:MM:SS, string:8}
  begin

   val(RAstr[1] + RAstr[2],h,code);
   val(RAstr[4] + RAstr[5],m,code);
   val(RAstr[7] + RAstr[8],s,code);

   tdbl := h + m/60.0 + s/3600.0;
  end
 else                     {Format is HH.FRACTION, double:8:5}
  begin

   val(RAstr[1] + RAstr[2],h,code);
   val(RAstr[4] + RAstr[5] + RAstr[6] + RAstr[7] + RAstr[8],m,code);

   tdbl := h + m/100000.0;
  end;
  while tdbl >= 24.0 do tdbl := tdbl - 24.0;
  RAtoDouble := tdbl;
end;

{CONVERT sDDdMM:SS OR sDD.FRACTION TO DOUBLE,ignore terminating "#" if any}
{Note: if fraction, 5 digits expected after decimal}
Function DECtoDouble(var DECstr:string):double;
var d, m, s,tdbl: double;
    code: integer;
begin
 if DECstr = '' then DECstr := '+00:00:00';
 if DECstr[4] = '.' then
  begin

   val(DECstr[2] + DECstr[3],d,code);
   val(DECstr[5] + DECstr[6] + DECstr[7] + DECstr[8] + DECstr[9],m,Code);

   tdbl := d + m/100000.0;
  end
 else
  begin

   val(DECstr[2] + DECstr[3],d,code);
   val(DECstr[5] + DECstr[6],m,Code);
   val(DECstr[8] + DECstr[9],s,Code);

   tdbl := d + m/60.0 + s/3600.0;
  end;

 if DECstr[1] = '-' then tdbl := -tdbl;
 DECtoDouble := tdbl;
end;

function RAtoString( RA: double): string;
var s: string;
begin
 dateTimeToString(s,'hh:mm:ss',RA/24.0);
 result := s
end;

 {CONVERT +/- DEG.FRACTION TO 'SDD.MM.SS'}
function DECtoString(doubleDEC: double): string;
var i: integer;
    temp: double;
    d,m,s: string[3];
    sign: string[2];
begin
 if doubleDec < 0 then sign := '-' else sign := '+';
 temp := abs(doubleDEC);
 str(trunc(temp):02,d);
 temp := 60.0*frac(temp);
 str(trunc(temp):02,m);
 temp := 60*frac(temp);
 str(round(temp):02,s);
 for i := 1 to 2 do
 begin
  if d[i] = ' ' then d[i] := '0';
  if m[i] = ' ' then m[i] := '0';
  if s[i] = ' ' then s[i] := '0';
 end;
 {DO NOT APPEND FINAL '#' FOR TELESCOPE COMMAND}
 result := sign + d + #223 + m + ':' + s;
end;


{Take a line of data from Boshart's SatTracker apart into its
elements. Used by procedure "Readdata" below. Correct for time zone.
Must modify time zone for daylight saving time. Offset negative for
West longitude. Note that StrToTime converts time string to days, while
DateTimeToString expects time in days. The "nn" in the format is correct;
"mm" would mean months}

procedure storedataline;
var buf2, buf3, buf4, buf5: string;
    tt: double;
    done: boolean;
    i: integer;

procedure getsubstring(var b: string; delim: char; var outstr: string; index: integer);
var c: char;
begin
 outstr := '';
 repeat
  c := b[i];
  done := (c = delim) or (i > length(b));
  inc(i);
  if not done then
    outstr := outstr + c;
 until done;
end;

begin
 i := 10;
 getsubstring(buffer,'|',timestr,i);
 tt := 24.0*StrToTime(timestr);   {Convert time string to hours, double}
 tt := tt + TimeZone;             {Add time zone}
 if tt < 0.0 then tt := tt + 24.0 {Fix 24-hr overflow}
 else
 if tt >= 24.0 then tt := tt - 24.0;
 DateTimetoString(timestr,'hh:nn:ss',tt/24.0); {Convert time to HMS string}

 getsubstring(buffer,'|',buf2,i);
 getsubstring(buffer,'|',buf3,i);
 getsubstring(buffer,'|',buf4,i);
 getsubstring(buffer,'|',buf5,i);

 AZlist^[dataptr]  := RAtoDouble(buf2);   //store position and time data
 AltList^[dataptr] := DECtoDouble(buf3);
 RAlist^[dataptr]  := RAtoDouble(buf4);
 DEClist^[dataptr] := DECtoDouble(buf5);

 TIMElist^[dataptr] := timestr;

 lastdataptr := dataptr;                   // update data size
end;

procedure readdata;
var datafile: text;
    i: integer;
    headlines: array[1..6] of string;
begin
 assignfile(datafile,'c:\lxsat\satpath.txt'); {Where data are expected to be}
 {$i-}
 reset(datafile);
 {$i+}
 if IOResult <> 0 then
  begin
   VidTrak10f.ObjName.caption := 'NO DATA FILE, CAN''T TRACK SATELLITE';
   nodata := true;
  end
 else
  begin
   writestatus('Satlog file found');
   nodata := false;
  end;
 if not nodata then
 begin
  for i := 1 to 6 do readln(datafile,headlines[i]);
  VidTrak10f.ObjName.caption := headlines[2];
  dataptr := 1;
  while not eof(datafile) do
   begin
    readln(datafile,buffer);
    storedataline;
    inc(dataptr);
   end;
  close(datafile);
 end;
end;

procedure showalignment;
begin
 with VidTrak10f do
 begin
  if alignment = 'A' then mount.caption := 'ALT-AZ'
  else if alignment = 'P' then mount.caption := 'POLAR'
  else if alignment = 'L' then mount.caption := 'LAND'
  else if alignment = 'G' then mount.caption := 'GERMAN';
 end;
end;

procedure readparams;
begin
with VidTrak10f do
begin
 assignfile(paramfile,'Param10f.txt');
 {$I-}
 reset(paramfile);
 {$I+}
 if IOResult = 0 then
   begin
   readln(paramfile, RefDEC);
   readln(paramfile, RefRA);
   readln(paramfile,TimeZone);
   readln(paramfile, ComPort);
   readln(paramfile, FL);
   label10.Caption := 'FL = ' + inttostr(FL) + ' mm';
   trackgain.Position := round(1000.0*ln(FL));
   readln(paramfile,nsegments);
   readln(paramfile,fieldwidth);
   readln(paramfile,fieldheight);
   readln(paramfile,Hsign);
   readln(paramfile,VSign);
   closefile(paramfile);
  end
else
 begin
  fieldwidth := 320;
  fieldheight := 240;
  refDEC := fieldheight div 2;
  refRA := fieldheight div 2;
  comport := 1;
  TimeZone := -7;
  FL := 102;
  trackgain.Position := round(1000.0*ln(1.0*FL));
  label10.Caption := 'FL = ' + inttostr(FL) + ' mm';
  Nsegments := 15;
  storeparams;
 end;
end;
end;

Function FixRA(s: string): string;
var temp: string;
begin
 if length(s) < 8 then result := 'NOT SET'
 else
 begin
  temp := s;
  temp[3] := 'h';
  temp[6] := 'm';
  if length(s) < 9 then temp := temp + 's'
  else temp[9] := 's';
  result := temp;
 end;
end;

function FixDEC(s: string): string;
var temp: string;
begin
 if length(s) < 9 then result := 'NOT SET'
 else
 begin
  temp := s;
  temp[4] := 'd';
  temp[7] := '''';
  if length(s) < 10 then temp := temp + '"'
  else temp[10] := '"';
  result := temp;
 end;
end;

procedure TVidTrak10f.FormCreate(Sender: TObject);
var i,count: integer;
    latstring: string;
begin
 iterating := false;
 getmem(RAlist,sizeof(DecimalType));
 getmem(DEClist,sizeof(DecimalType));
 getmem(TIMElist,sizeof(StringType));
 getmem(AltList,sizeof(DecimalType));
 getmem(AZlist,sizeof(DecimalType));

 readdata;      // load pass file
 readparams;   //LOAD IN PARAMETERS, INCLUDING WINDOW SIZE
 StarTrakSize := fieldheight div 20;
 StarTrakSize := StarTrakSize * 2 + 1;   // odd number of pixels
 halfframe    := StarTrakSize div 2;

 hWndC := capCreateCaptureWindowA('FINDER FIELD',
                                      WS_CHILD,           // NOT VISIBLE
                                      0,
                                      0,
                                      fieldwidth,
                                      fieldheight,
                                      VidTrak10f.Handle,
                                      0);
 if hWndC <> 0 then
   SendMessage(hWndC, WM_CAP_DRIVER_CONNECT, 0, 0);


 bitmap1 := TBitmap.Create;
 Bitmap1.pixelformat := pf24bit;
 bitmap1.width := fieldwidth;     // full picture
 bitmap1.height := fieldheight;
 bitmap2 := TBitmap.Create;
 Bitmap2.pixelformat := pf24bit;
 bitmap2.width := StarTrakSize;  // subframe
 bitmap2.height := StarTrakSize;

 // Precalculate pointers to scan lines in subframe
 for i := 0 to startraksize - 1 do maplist[i] := bitmap2.ScanLine[i];

 with afComPort1 do
 begin
  ComNumber := Comport;
  Baudrate := br9600;
  Parity := paNone;
  StopBits := sbOne;
  Databits := db8;
  DTR := false;
  FlowControl := fwNone;
  Open;
 end;

 nodata := true;
 stop := false;
 autoon := false;
 polar := true;
 pulse := true;
 limDEC := false;
 memoOK := false;
 slewdone := false;
 moveframe := false;

 stepsize := 10;
 borestate := 0;
 borestep := 0;
 boresight.Caption := 'OFF';
 thresh := 1.5;
 threshold.text := '1.5';
 queryperformancefrequency(freq);
 segtime := freq div nsegments;
 segment := 0;
 radiogroup1.ItemIndex := 0;
 MaxTime := 0.0;
 SetTelTime;
 stage := 0;
 instr := '';
 writestatus('Initialized');
 application.onIdle := idleloop;
 fieldradius := StarTraksize div 2;
 cornerRA := 1;
 cornerDEC := 1;
 field := Rect(cornerRA, cornerDEC,
                cornerRA + StarTrakSize - 1,cornerDEC + StarTrakSize - 1);
 count := 100;
 with afComPort1 do
 repeat
  writechar(#6);  // read telescope alignment mode (P,A, L, G)
  delay(100);
  dec(count);
  alignment := readchar;
 until (alignment in ['A','G','P','L']) or (count <= 0);
 if count <= 0 then alignment := 'A'
 else alignment := 'P';  // most likely kind
 showalignment;
 fieldscale := 2.0/fieldheight;   // field scale in degrees per pixel
 gain := 102.0/FL;
 gainfactor := 1;

 afComPort1.purgeRX;
 comTXstring(':Gt#;');           // get latitude from telescope;
 comRXstring(latstring,'#');
 delete(latstring, length(latstring),1); // get rid of #
 latstring[4] := '.';
 latitude := strtofloat(latstring);

 SetLongForm;
 memo1.clear;
 comTxString(':FS#');  // slow focus
 Focusstr := '';       // no focus command
 iterating := true;
 homer.Caption := 'Go To Home';
 maxval := 0;
 avgval := 0;
 s1 := 0; s2 := 0; s3 := 0;
 slow := 15;
 queryperformancecounter(Tend);
end;

procedure GetTelData; {read and save input buffer data}
begin
 {accumulate string and exit, process string if "#" terminator}
 with VidTrak10f.afComPort1 do
 while InBufUsed > 0 do
 begin
  ch := readchar;
  if ch <> '#' then instr := instr + ch  // accumulate string
  else
  begin                                  // process string if '#'
   if pos(instr,'Object') <> 0 then
    VidTrak10f.Distance.caption := 'OBJECT BELOW HORIZON'
   else if (length(instr) > 7) and
     (instr[length(instr)-5] = ':') then  {Check for RA return string}
    begin
     TelRAString := copy(instr,length(instr) - 7,8);
     TelRA := RAtoDouble(TelRAstring);
    end
   else if length(instr) > 8 then
   begin
    TelDecString := copy(instr,length(instr) - 8,9);
    TelDec := DECtoDouble(TelDECstring);
   end;
   instr := ''; {clear input string after each "#"}
  end;
 end;
end;

procedure MoveTelescope;         // slew toward object RA and DEC
begin
 comTXstring(setObjRA + ObjRAstring + '#'
             + setObjDEC + ObjDECString + '#'
             + SlewTel
             + Focusstr    // If focus command, execute
             + Commandstr);  // If other command, execute
 Focusstr := '';
 commandstr := '';
end;

{$J+}
function getdistance: integer;   // return distance remaining to target
var dist: integer;
    dRA: double;
begin
  if (TelDECstring <> '') and
     (ObjDECstring <> '') and
     (TelRAstring <> '') and
     (ObjRAstring <> '') then
 begin
  TelRA := RAtoDouble(TelRAstring);
  ObjRA := RAtoDouble(ObjRAstring);
  TelDec := DECtoDouble(TelDECstring);
  ObjDEC := DECtoDouble(ObjDECstring);
  dRA := objRA - TelRA;
  if dRA >= 12.0 then dRA := dRA - 24.0
  else
  if dRA < -12.0 then dRA := dRA + 24.0;
  dist := round(sqrt(sqr(60.0*(ObjDEC - TelDEC)) + sqr(900.0*dRA)));
  result := dist;
  VidTrak10f.distance.caption := 'Distance = ' + inttostr(dist);
 end
 else result := 10000;
end;

procedure interpolate;
var timenow,nexttime: TDatetime;
begin
 timenow := 0;
 nexttime := 0;
 with VidTrak10f do
 repeat
  if dataptr < lastdataptr - 3 then
  begin
   nexttime := StrToTime(timelist^[dataptr + 1]);
   timenow := time;
   if nexttime < timenow then inc(dataptr);
  end;
 until (nexttime >= timenow) or (dataptr >= lastdataptr - 3);
 if dataptr < lastdataptr - 3 then
 begin
  ThisRA := RAlist^[dataptr + 2];     // two second time advance
  ThisDEC := DEClist^[dataptr + 2];
  NextRA := RAlist^[dataptr + 3];
  NextDEC := DEClist^[dataptr + 3];
  inc(dataptr);
  deltaDEC := (nextDEC - thisDEC)/nsegments;
  deltaRA  := (nextRA - ThisRA)/nsegments;
  if deltaRA >= 12.0 then deltaRA := deltaRA - 24.0
  else
  if deltaRA < -12.0 then deltaRA := deltaRA + 24.0;
 end
 else stop := true;
end;

function NextPosition: boolean; // set object RA and DEC to next position
var setok: boolean;
    num, denom: double;
    corrRA, newRA, corrDEC, tempDEC: double;
begin
  setok := (dataptr <= lastdataptr - 1);
  if (stage = 1) or (not autoon) then
   begin
    autoDec := 0.0;
    autoRA := 0.0;
   end;
  gain := exp(102/FL); // why exponential? Saved as ln ?
  if autoon then
   begin
    autoDEC := autoDEC + errDEC;  // integral output
    autoRA := (autoRA + errRA/15.0);
    corrDEC := VSign*Gain*0.01*(autoDEC + 0.7*ErrDEC);
    corrRA  := gainfactor * HSign*Gain*0.01*(autoRA  + 0.7*ErrRA);
   end
  else
   begin
    corrRA := 0.0;
    corrDEC := 0.0;
    autoDEC := 0.0;
    autoRA := 0.0;
   end;
  if setok then
  with VidTrak10f do
  begin
   if (segment = 0) then
    begin
     if alignment = 'A' then gainfactor := cos(pi/180.0*altlist^[dataptr])
     else gainfactor := cos(pi/180.0*declist^[dataptr]);
     if abs(gainfactor) < 0.1 then gainfactor := 0.1;
     gainfactor := 1.0/gainfactor;  // gain increase toward pole of motion
     interpolate;
     num := dataptr;
     denom := lastdataptr;
     writestatus('  ' + inttostr(round(100.0*num/denom)) + ' % of pass');
                       // should go every second
    end;
    tempDEC := thisDEC + deltaDEC*segment + corrDEC + Yoffset/60.0; // DEGREES
    if LimDEC then
     if TempDEC > DEClimit then TempDEC := DEClimit;
    ObjDEC := tempDEC;
    objDECstring := DECtoString(ObjDEC);
    newRA := ThisRA + deltaRA*segment + corrRA + Xoffset/15.0/60.0; // HOURS
    if newRA >= 24.0 then newRA := newRA - 24.0
    else
    if newRA < 0 then  newRA := newRA + 24.0;
    objRAstring := RAtoString(newRA);
  end;
  result:= setok;
end;

function waitstart: boolean;
begin
 with VidTrak10f do
 begin
  timenow := time;
  writestatus('START PASS: ' + TimeToStr(starttime)
                    + '              TIME NOW: ' + TimeToStr(timenow));
 end;
 result :=  timenow >= starttime;
end;

procedure setstart;
var deltaRA, DELTAdec, nextRA: double;
begin
 dataptr := 1;
 starttime := StrToTime(timelist^[dataptr]);
 segment := 0;
 // if DEC change is negative,
 // Do not accept negative change in RA: indicates that
 // satellite will pass below pole and require large
 // change in telescope RA ( > 12 hours). Skip ahead until
 // change is positive or end of data.
 repeat
  ObjRA := RAlist^[dataptr];
  ObjDEC := DEClist^[dataptr];
  nextRA := RAlist^[dataptr+5];
  deltaRA := nextRA - ObjRA;
  deltaDEC := DEClist^[dataptr+5] - DEClist^[dataptr];
  if DeltaRA >= 12.0 then DeltaRA := DeltaRA - 24
  else
  if DeltaRA <= -12 then DeltaRA := DeltaRA + 24;
  if ((deltaRA < 0) and (deltaDEC < 0)) then inc(dataptr);
 until (deltaRA >= 0.0) or (deltaDEC > 0.0)or (dataptr >= lastdataptr - 5);
 if dataptr < lastdataptr - 5 then
 begin
  ObjRAstring := RAtoString(ObjRA);
  ObjDECstring := DECtoString(ObjDEC);
 end
 else
  begin
   dataptr := lastdataptr + 1;
   stage := 0;
  end;
end;

procedure sethome;  // Home position: RA = sidereal time, DEC = 0
begin
 VidTrak10f.afComPort1.PurgeRX;
 ObjRAstring := '';
 repeat
  ComTxString(GetSidTime);
  ComRxString(ObjRaString,'#');
 until length(objRAstring) = 9;
 ObjDECstring := '+00d00m00s'
end;

{MAKES SURE RA IS HH:MM:SS AND DEC IS sDD:MM:SS}
procedure setlongform;
var tries: integer;
begin
  tries := 0;
  telRAstring := '';
  repeat
   comTXstring(getTelRA);
   if not comRXstring(TelRAstring,'#') then
   inc(tries);
   delay(1000);
  until (TelRAstring <> '') or (tries >= 3);
  if tries >= 3 then
   begin
    writestatus('TELESCOPE NOT RESPONDING');
    delay(1000);
    application.terminate;
   end;
  if length(telRAstring) < 9 then
   repeat
    ComTxString(':U#');  { toggle precision}
    delay(500);
    ComTxString(getTelRA);
    if not ComRxString(telRAstring,'#') then halt;
   until length(telRAstring) >= 9;
end;

procedure closeprogram;
begin
with VidTrak10f do
begin
 comTXstring(':FQ#'); // quit focus
 comTXstring(':Q#');  // quit motion
 stopvideo;
 application.Terminate;
end;
end;


{$J+}
procedure iterate;

procedure restart;
begin
 with VidTrak10f do
 begin
  Homer.Caption := 'Go To Home';
  Homer.checked := false;
  Auto.caption := 'Auto (Off)';
  Auto.checked := false;
  Autoon := false;
  tracker.Checked := false;
  stopper.Checked := false;
  stop := false;
  Progress.Caption :=
       'WAITING FOR COMMAND -- CLICK STOP TO EXIT PROGRAM';
  Distance.Caption := '';
  stage := 0;
 end;
end;

begin  // begin iteration control loop
 tstart := tend; // compute iterations (frames) per second
 queryperformancecounter(tend);
 s1 := s1 + (slow*(tend - Tstart) - s1) div slow; // running average
 s2 := s2 + (s1 - s2) div slow;
 s3 := s3 + (s2 - s3) div slow;
 if (tend - tstart) > maxval then maxval := (tend - tstart);
 VidTrak10f.FrameRate.caption :=
      floattostrf(1e6/(s3*1000000.0/freq/slow),fffixed,5,1);
 grabframe;
 copyframe;
 if iterating then
  with VidTrak10f do
  begin
    case stage of
      //HOMING STARTS HERE
      1: if alignment = 'P' then
         begin
          sethome;
          Progress.Caption := ('HOMING');
          Homer.Caption := 'Homing';
          Writestatus('');
          stage := 2;
         end
         else stage := 0;
      2: if getdistance < 1 then
          begin
           writestatus('HOME POSITION');
           restart;
          end;
       //TRACKING STARTS HERE
      3: begin
          setstart;
          stage := 4;
          VidTrak10f.Progress.Caption :=
            'WAITING FOR SATELLITE -- CLICK STOP TO ABORT';
         end;
      4: if waitstart then // if false, keep waiting
          begin
           stage := 5;
           VidTrak10f.Progress.Caption :=
             'TRACKING SATELLITE -- CLICK STOP TO ABORT';
          end;
      5: if not NextPosition then restart; // restart if end of pass detected
      6: if getdistance < 1 then  // called when slewing to object
          begin
           slewdone := true;
           restart;
          end;

     end; // of case statement
   if stage in [2,4,5] then movetelescope;
   // ALWAYS SHOW OBJECT (TARGET) POSITION
   label3.caption := fixRA(ObjRAstring);
   label4.caption := fixDEC(ObjDECstring);
   // SHOW TELESCOPE POSITION ONLY WHEN NOT TRACKING
   if stage <> 5 then
   begin
    comTXstring(getTelRA);
    comTXstring(getTelDEC);
    GetTelData;
    label1.Caption := fixRA(TelRAstring);
    label2.Caption := fixDEC(TelDECstring);
   end;
   if stop then
   begin
    stop := false;
    if stage = 0 then closeprogram else restart;
   end;
  end;   // if iterating and is comport
end;

procedure TVidTrak10f.Cleanup(Sender: TObject; var Action: TCloseAction);
begin
 freemem(AZlist,sizeof(DecimalType));
 freemem(AltList,sizeof(DecimalType));
 freemem(TIMElist,sizeof(StringType));
 freemem(DEClist,sizeof(DecimalType));
 freemem(RAlist,sizeof(DecimalType));
end;

procedure TVidTrak10f.KeyCommand(Sender: TObject; var Key: Char);
begin
 if key in ['q','Q'] then closeprogram;
end;

procedure TVidTrak10f.RadioGroup1Click(Sender: TObject);
var cmdstr: string;
begin
 case radiogroup1.ItemIndex of
  0: cmdstr := ':RS#';   { Speed control: returns nothing}
  1: cmdstr := ':RM#';
  2: cmdstr := ':RC#';
  3: cmdstr := ':RG#';
 end;
 ComTxString(cmdstr);
end;

procedure TVidTrak10f.GoNorth(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if stage = 0 then
  comTXstring (':Mn#')
  else
  if stage = 5 then
   Yoffset := Yoffset + stepsize;
end;

procedure TVidTrak10f.StopNorth(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if stage = 0 then
 begin
  ComTXString(':Qn#');
  comTXstring(':Q#');
 end;
end;

procedure TVidTrak10f.GoWest(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if stage = 0 then
 ComTxString(':Mw#')
 else
 if stage = 5 then
 Xoffset := Xoffset - stepsize;;
end;

procedure TVidTrak10f.StopWest(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if stage = 0 then
 begin
  ComTxString(':Qw#');
  ComTxString(':Q#');
 end;
end;

procedure TVidTrak10f.GoSouth(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if stage = 0 then
  ComTxString(':Ms#')
  else if stage = 5 then
   Yoffset := Yoffset - stepsize;
end;

procedure TVidTrak10f.StopSouth(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if stage = 0 then
 begin
  ComTxString(':Qs#');
  ComTxString(':Q#');
 end;
end;

procedure TVidTrak10f.GoEast(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if stage = 0 then
  ComTxString(':Me#')
 else
 if stage = 5 then
  Xoffset := Xoffset + stepsize;
end;

procedure TVidTrak10f.StopEast(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if stage = 0 then
 begin
  ComTxString(':Qe#');
  ComTxString(':Q#');
 end;
end;

procedure TVidTrak10f.idleloop(Sender: TObject; var Done: boolean);
var t1, t2: int64;
begin
 done := false;
 QueryPerformanceCounter(t1);
 iterate;
 if segment = nsegments - 1 then
 begin
  repeat
   t4 := round(time * 86400.0); // sync to exact second
   application.ProcessMessages;
  until (t4 <> t3);    // global variables
  t3 := t4;  // set value for next second.
 end
 else
 repeat
  QueryPerformanceCounter(t2);
  application.ProcessMessages;
 until t2 - t1 >= segtime;  // finish out segment time
 inc(segment);
 if segment > nsegments - 1 then segment := 0;
end;

procedure TVidTrak10f.StopperClick(Sender: TObject);
begin
 stop := true;
end;

procedure TVidTrak10f.FormatClick(Sender: TObject);
begin
 if hWndC <> 0 then
  SendMessage(hWndC, WM_CAP_DLG_VIDEOFORMAT, 0, 0);
end;

procedure TVidTrak10f.DisplayClick(Sender: TObject);
begin
 if hWndC <> 0 then
  SendMessage(hWndC, WM_CAP_DLG_VIDEOSOURCE, 0, 0);
end;

procedure TVidTrak10f.AutoClick(Sender: TObject);
begin
 if stage = 5 then
 begin
  autoon := not autoon;
  if autoon then auto.caption := 'Auto Is On'
  else auto.caption := 'Auto Is Off';
 end
 else
  begin
   Auto.checked := false;
   auto.caption := 'Auto Is Off';
   autoon := false;
  end;
end;

procedure TVidTrak10f.HomerClick(Sender: TObject);
begin
 if stage = 0 then
  begin
   stage := 1;
   pickstar.Text := '';
  end
  else Homer.checked := false;
end;

procedure TVidTrak10f.trackerClick(Sender: TObject);
begin
 if (stage = 0) and (not nodata) then
  begin
   stage := 3;
   pickstar.Text := '';
  end
 else tracker.checked := false;
end;

procedure TVidTrak10f.Setfield(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
  var xx,yy: integer;
begin
  xx := X;
  if xx < 1 then xx := 1
  else
  if xx > fieldwidth - 1 then xx := fieldwidth - 1;
  yy := Y;
  if yy < 1 then yy := 1
  else
  if yy > fieldheight - 1 then yy := fieldheight - 1;
  peakx := xx;
  peaky := yy;
  moveframe := true;
end;

procedure TVidTrak10f.StartFocIn(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if stage <> 5 then
  begin
   comTxString(':F-#');
   if pulse then
   begin
    delay(200);
    comTXstring(':FQ#');
   end;
  end
  else
  Focusstr := ':F-#';
end;

procedure TVidTrak10f.StopFocIn(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if stage <> 5 then comTXstring(':FQ#')
 else
 focusstr := ':FQ#';
end;

procedure TVidTrak10f.StartFocOut(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if stage <> 5 then
  begin
   comTXstring(':F+#');
   if pulse then
   begin
    delay(200);
    comTXstring(':FQ#');
   end;
  end
  else
  Focusstr := ':F+#';
end;

procedure TVidTrak10f.StopFocOut(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if stage <> 5 then comTXstring(':FQ#')
 else
 Focusstr := ':FQ#';
end;

procedure TVidTrak10f.PulsedClick(Sender: TObject);
begin
 pulse := not pulse;
 if pulse then pulsed.caption := 'Pulsed'
 else pulsed.caption := 'Contin';
end;

procedure TVidTrak10f.SeekStar(Sender: TObject; var Key: Char);
begin
 if (key = #13) and (stage = 0) then
 begin
  comTxString(':LS ' + pickstar.Text + '#');
  delay(200);
  VidTrak10f.AfComPort1.purgeRX;
  comTXstring(':Gr#');
  ComRxString(ObjRAstring,'#');
  SaveObjRAstring := ObjRAstring;
  comTXstring(':Gd#');
  ComRxString(ObjDECstring,'#');
  SaveObjDECstring := ObjDECstring;
  comTXstring(Slewtel);
  slewdone := false;
  stage := 6;
 end;
end;

procedure TVidTrak10f.TrackGainChange(Sender: TObject);
begin
  FL := round(exp(0.001*Trackgain.position));
  gain := 102.0/FL;
   label10.Caption :=
    'FL = ' + inttostr(FL) + ' mm';
end;

procedure TVidTrak10f.SyncClick(Sender: TObject);
var retstr: string;
begin
 if (not slewdone) or (stage <> 0) or (Pickstar.Text = '') or
    (length(SaveObjRAstring) < 8) or
    (length(SaveObjDECstring) < 9)
    then exit;
 ComTXstring(SetObjRA +
             SaveObjRAstring + '#' +
             SetObjDEC +
             SaveObjDECstring + '#' +
             ':CM#'); // telescope sync to object
 comRxString(retstr,'#');
 pickstar.Text := '';
 slewdone := false;
end;

procedure TVidTrak10f.loadfile(Sender: TObject);
begin
 if stage = 0 then readdata;
end;


procedure TVidTrak10f.ParameditClick(Sender: TObject);
begin
 doParamEdit;
end;


procedure TVidTrak10f.ParamSaveClick(Sender: TObject);
begin
 doParamSave;
end;

procedure TVidTrak10f.StepClick(Sender: TObject);
begin
 if stepsize <> 10 then stepsize := 10
 else stepsize := 1;
 if stepsize = 1 then step.caption := 'X1'
 else step.caption := 'X10';
end;


procedure TVidTrak10f.BoresightClick(Sender: TObject);
begin
 borestate := (borestate + 1) mod 3;
 case borestate of
  0: borestep := 0;
  1: borestep := 1;
  2: borestep := 5;
 end;
 if borestate <> 0 then
  boresight.caption := 'x' + inttostr(borestep)
 else
  boresight.caption := 'OFF';
end;

procedure TVidTrak10f.BoreUpClick(Sender: TObject);
begin
 refdec := refdec - borestep;
end;

procedure TVidTrak10f.BoreRightClick(Sender: TObject);
begin
 refRA := refRA + borestep;
end;

procedure TVidTrak10f.BoreDownClick(Sender: TObject);
begin
 refDEC := refDEC + borestep;
end;

procedure TVidTrak10f.BoreLeftClick(Sender: TObject);
begin
 refRA := refRA - borestep;
end;

procedure TVidTrak10f.zeroClick(Sender: TObject);
begin
 refDEC :=  fieldheight div 2;
 refRA := fieldwidth div 2;
end;

end.
